# Which quicksort variants should be tested?
# First parameter is pivot number, remaining
# k + 1 parameters are number of sampled out 
# elements.

param[0]="1 0 0"
param[1]="2 0 0 0"
param[2]="2 0 1 1"
param[3]="3 0 0 0 0"
param[4]="3 0 2 2 0"
param[5]="4 0 0 0 0 0"
param[6]="4 0 0 2 2 0"
param[7]="5 0 0 0 0 0 0"
param[8]="5 0 0 1 1 0 0"
param[9]="6 0 0 0 0 0 0 0"
param[10]="6 0 1 1 3 3 1 1"
param[11]="7 0 0 0 0 0 0 0 0"
param[12]="7 0 0 0 4 4 0 0 0"
param[13]="8 0 0 0 0 0 0 0 0 0"
param[14]="8 0 0 1 3 3 1 0 0 0"
param[15]="9 0 0 0 0 0 0 0 0 0 0"
param[16]="9 0 0 0 0 2 2 0 0 0 0"
param[17]="15 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0"

rm ../src/algorithms/included_algorithms.h

# Fixed algorithms not generated automatically.
# See ../src/algorithms/ for a list of algorithms.

echo \#include \"qsort1is.h\" >> ../src/algorithms/included_algorithms.h;
echo \#include \"qsort2v5.h\" >> ../src/algorithms/included_algorithms.h;
echo \#include \"qsort3.h\" >> ../src/algorithms/included_algorithms.h;

# Generate algorithms by invoking gen_k_pivot_algorithm.rb

for i in "${param[@]}";
do
    FILENAME=qs-${i}.h;
    echo Generating ${FILENAME};
    ruby ../ruby-scripts/gen_k_pivot_algorithm.rb $i > "../src/algorithms/$FILENAME";
    echo \#include \"$FILENAME\" >> ../src/algorithms/included_algorithms.h;
done

mkdir -p ../bin
cd ../bin
cmake -DCMAKE_BUILD_TYPE=Release ../
make
mv src/qstest ../examples/qs-example
